<template>
    <b-modal
        :id="id"
        ref="modal-test-csv-file"
        title="Test CSV File"
        no-close-on-backdrop
        no-close-on-esc
        ok-only
        size="lg"
    >
        <b-overlay :show="showOverlay" rounded="sm">
            <div class="modal-form-header">
                <b-form-file
                    size="sm"
                    v-model="file"
                    :state="Boolean(file)"
                    placeholder="Choose a file or drop it here..."
                    drop-placeholder="Drop file here..."
                    accept=".csv"
                ></b-form-file>
                <div class="text-center" style="padding-top: 10px;">
                    <b-button
                        @click="doUpload"
                        :disabled="!(Boolean(file))"
                        variant="outline-primary"
                        size="sm"
                    >Upload file</b-button>
                </div>
            </div>
            <div class="modal-form-content">
                <div v-if="displayResult">
                    <phone-number-result-statistics
                        description="Test completed with the following results:"
                        :successful="statSuccesful"
                        :corrected="statCorrected"
                        :failure="statFailure"
                    ></phone-number-result-statistics>

                    <search-input v-model="search" />

                    <phone-number-result-displayer
                        :no-items-text="displayerNoItemsText"
                        :successful-items="succesfulItems"
                        :corrected-items="correctedItems"
                        :failure-items="failureItems"
                        :limit-results="50"
                    ></phone-number-result-displayer>
                </div>
                <div v-else-if="displayError">
                    <b-alert variant="danger" show>
                        <b-icon-x-circle-fill></b-icon-x-circle-fill>
                        &nbsp;
                        {{errorMessage}}
                    </b-alert>
                </div>
                <div v-else>
                    <p>
                        <small>Use the form above to pick a CSV file containing at least the columns 'id' and 'sms_phone', respectivetly an id of the single request to do and the value to verify, and upload it to our api server.</small>
                    </p>
                </div>
            </div>
        </b-overlay>
        <template v-slot:modal-footer>
            <!-- Emulate built in modal header close button action -->
            <b-button size="sm" variant="outline-primary" @click="close">Close</b-button>
        </template>
    </b-modal>
</template>

<script>
import _ from "lodash";
import { BIconXCircleFill } from "bootstrap-vue";
import PhoneNumberService from "../services/phone-number-service";
import { EventBus } from "../plugins/global-event-bus";
import { VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED } from "../configs/config";

import SearchInput from "./SearchInput.vue";
import PhoneNumberResultDisplayer from "./PhoneNumberResultDisplayer.vue";
import PhoneNumberResultStatistics from "./PhoneNumberResultStatistics.vue";

export default {
    name: "ModalTestCSVFile",
    components: {
        BIconXCircleFill,
        SearchInput,
        PhoneNumberResultDisplayer,
        PhoneNumberResultStatistics,
    },
    props: {
        id: String,
    },
    data() {
        return {
            search: "",
            showOverlay: false,
            file: null,
            displayResult: false,
            displayError: false,
            errorMessage: null,
            statSuccesful: 0,
            statCorrected: 0,
            statFailure: 0,
            resultItems: null,
        };
    },
    computed: {
        succesfulItems() {
            if (this.resultItems instanceof Array) {
                const items = _.filter(this.resultItems, {
                    isValid: true,
                    isCorrected: false,
                });
                if (this.search) {
                    return _.filter(items, (item) => item.match(this.search));
                }
                return items;
            }
            return [];
        },
        correctedItems() {
            if (this.resultItems instanceof Array) {
                const items = _.filter(this.resultItems, {
                    isValid: true,
                    isCorrected: true,
                });
                if (this.search) {
                    return _.filter(items, (item) => item.match(this.search));
                }
                return items;
            }
            return [];
        },
        failureItems() {
            if (this.resultItems instanceof Array) {
                const items = _.filter(this.resultItems, { isValid: false });
                if (this.search) {
                    return _.filter(items, (item) => item.match(this.search));
                }
                return items;
            }
            return [];
        },
        displayerNoItemsText() {
            if (this.search) {
                return "No items found that match your search";
            }
            return "There are no items to show";
        },
    },
    methods: {
        doUpload() {
            PhoneNumberService.testCSVFile(this.file)
                .then((result) => {
                    this._setResult(result.stats, result.items);

                    EventBus.$emit(VUE_GLOBAL_EVENT_PHONE_LIST_UPDATED);
                })
                .catch((err) => {
                    this._setError(err);
                })
                .finally(() => {
                    this.showOverlay = false;
                });
        },
        _setResult(stats, items) {
            this.statSuccesful = stats.successful || 0;
            this.statCorrected = stats.corrected || 0;
            this.statFailure = stats.failure || 0;

            this.resultItems = items;

            this.errorMessage = null;
            this.displayError = false;
            this.displayResult = true;
        },
        _setError(err) {
            this.displayResult = false;
            this.errorMessage = err.message;
            this.displayError = true;
        },
        close(e) {
            if (this.resultItems) {
                e.preventDefault();

                this.$bvModal.msgBoxConfirm("Are you sure?").then((value) => {
                    if (value) {
                        this.$refs["modal-test-csv-file"].hide();
                    }
                });
                return;
            }
            this.$refs["modal-test-csv-file"].hide();
        }
    },
    mounted() {
        this.file = null;
        this.search = "";
        this.displayError = false;
        this.displayResult = false;
        this.errorMessage = null;
    },
    destroyed() {
        this.file = null;
        this.search = "";
        this.displayError = false;
        this.displayResult = false;
        this.errorMessage = null;
    },
};
</script>

<style scoped>
.modal-form-header {
    padding: 10px 0;
    border-bottom: 1px solid #ccc;
}
.modal-form-content {
    padding-top: 10px;
}
</style>